#include "jw_bsp_init.h"
#include "SWM221.h"

/*
 * SerialInit
 * ܣʼUART0ͨ
 * 
 * ֵ
 * עPA.0ΪUART0_RXPA.1ΪUART0_TX
 *     576008λݣУ飬1λֹͣλ
 *     FIFOֵշ3ֽʱжδʹܣ
 *     ճʱʱ10λ嵥λοӲֲᣩʱжδʹ
 */
static void SerialInit(void)
{
    UART_InitStructure UART_initStruct;
    
    // PA0ΪUART0չܣ
    PORT_Init(PORTA, PIN0, PORTA_PIN0_UART0_RX, 1); 
    // PA1ΪUART0͹ܣ
    PORT_Init(PORTA, PIN1, PORTA_PIN1_UART0_TX, 0); 
    
    // ʼUARTýṹ
    UART_initStruct.Baudrate = 115200;       // 115200bps
    UART_initStruct.DataBits = UART_DATA_8BIT; // 8λλ
    UART_initStruct.Parity = UART_PARITY_NONE; // У
    UART_initStruct.StopBits = UART_STOP_1BIT; // 1λֹͣλ
    UART_initStruct.RXThreshold = 3;       // FIFOֵ3ֽ
    UART_initStruct.RXThresholdIEn = 1;    // ֵж
    UART_initStruct.TXThreshold = 3;       // FIFOֵ3ֽ
    UART_initStruct.TXThresholdIEn = 0;    // ÷ֵж
    UART_initStruct.TimeoutTime = 10;      // ճʱʱ䣨λӲ10ַʱδյµ򴥷ʱж
    UART_initStruct.TimeoutIEn = 1;        // óʱж
    
    // ӦòUART0
    UART_Init(UART0, &UART_initStruct);    // ʼUART0
    UART_Open(UART0);                      // UART0ͨ
}

/*	CAN˿ڳʼ	*/
static void CanInit(void)
{
	CAN_InitStructure CAN_initStruct;  // CANʼṹ
    
	// ʼPORTB78ΪCAN0RX/TX
    // ˿, ź, ù, /ʹܣ1-ʹܣ0-ã   
	PORT_Init(PORTB, PIN7, PORTB_PIN7_CAN0_RX, 1);  // CAN0
    PORT_Init(PORTB, PIN8, PORTB_PIN8_CAN0_TX, 0);  // CAN0    
		
    // CANʼ
    CAN_initStruct.Mode = CAN_MODE_NORMAL;		//ģʽ		// Բģʽ̽TXRXCAN_MODE_SELFTEST;//
    CAN_initStruct.CAN_bs1 = CAN_BS1_5tq;       // λʱ1ռ5ʱ䵥λ
    CAN_initStruct.CAN_bs2 = CAN_BS2_4tq;       // λʱ2ռ4ʱ䵥λ
    CAN_initStruct.CAN_sjw = CAN_SJW_2tq;       // ͬת2ʱ䵥λ
    CAN_initStruct.Baudrate = 500000;            // 500kbps
    CAN_initStruct.RXNotEmptyIEn = 1;           // ýж
    CAN_initStruct.ArbitrLostIEn = 0;           // ٲöʧж
    CAN_initStruct.ErrPassiveIEn = 1;           // ô󱻶ж
    CAN_Init(CAN0, &CAN_initStruct);            // ӦóʼCAN0
    
	/* CANж */
	CAN_INTEn(CAN0, CAN_IT_ERR_WARN | CAN_IT_RX_OVERFLOW);	
	
	/*	 32λIDģʽ	*/	
	CAN_SetFilter32b(CAN0, CAN_FILTER_1, 0x00202001, 0x1FF0FCF8);	//չIDΪ0x00202001~0x00202304֡  MC
	CAN_SetFilter32b(CAN0, CAN_FILTER_2, 0x00182001, 0x1FF8FCFC);	//չIDΪ0x00182001~0x00182303֡  BMS
	CAN_SetFilter32b(CAN0, CAN_FILTER_3, 0x00282301, 0x1FF8FFFC);	//չIDΪ0x00282301~0x002F2301֡  VCU
	CAN_SetFilter32b(CAN0, CAN_FILTER_4, 0x00282001, 0x1FF8FCFF);	//չIDΪ0x00282001~0x00282201֡  VCU
	CAN_SetFilter32b(CAN0, CAN_FILTER_5, 0x00302001, 0x1FF0FCFF);	//չIDΪ0x00302001~0x00372301֡  HIMI
	CAN_SetFilter32b(CAN0, CAN_FILTER_6, 0x00382301, 0x1FF8FFFF);	//չIDΪ0x00382301~0x003F2301֡  ABS
	CAN_SetFilter32b(CAN0, CAN_FILTER_7, 0x00382001, 0x1FF8FCFF);	//չIDΪ0x00382001~0x003F2201֡  ABS
	CAN_SetFilter32b(CAN0, CAN_FILTER_8, 0x00402001, 0x1FF0FCFF);	//չIDΪ0x00402001~0x00402301֡  ƿغ
	CAN_SetFilter32b(CAN0, CAN_FILTER_9, 0x00482001, 0x1FF8FCFF);	//չIDΪ0x00482001~0x004F2301֡  ״
//	CAN_SetFilter32b(CAN0, CAN_FILTER_8, 0x00402001, 0x1FF0FCFF);	//չIDΪ0x00402001~0x00402301֡  ƿغ
	
	
    CAN_Open(CAN0);  // CAN0
}

/**
  * @brief  SysTickʱΪ1msжһ 
  * @note   ʼʧܣʱԴ쳣򽫽ѭ 
  */
static void SysTick_Configuration(void)
{    
    /* SysTick_Config1msжϣ
       - SystemCoreClock/1000ʾCPUʱӷƵΪ1KHz 
       - ط0ֵʾʧܣʱԴδ */
    if (SysTick_Config(SystemCoreClock / 1000)) // 1ms tick 
    { 
		LOG("SysTick ERROR !!!\r\n");
        /* ʼʧʱ */
        while (1);
    }
    
    /* SysTickжȼΪߣ0x00
       - SysTick_IRQnںжϵöٱʶ */
    NVIC_SetPriority(SysTick_IRQn, 0x00);
}

void SysTick_Handler(void)
{	
	//Timer_Task_1ms();
}

/**********	ϵͳʼ	********/
void bsp_init(void)
{
	SystemInit();
	GPIO_Init(GPIOA, PIN3, 1, 0, 1, 0);		//MCUʹ
	SerialInit();							//ڳʼ
	CanInit();	
	SysTick_Configuration();         		// SysTickϵͳʱڲʱжϣ
}
