#ifndef __SWM221_ADC_H__
#define	__SWM221_ADC_H__


typedef struct {
	uint8_t  clkdiv;		//1-32
	uint8_t  refsrc;		//ADC_REF_VDDADC_REF_REFPADC_REF_2V4ADC_REF_3V6ADC_REF_4V5
	uint8_t  samplAvg;		//ADC_AVG_SAMPLE1ADC_AVG_SAMPLE2ADC_AVG_SAMPLE4ADC_AVG_SAMPLE8
} ADC_InitStructure;


typedef struct {
	uint8_t  trig_src;		//ADCдʽADC_TRIGGER_SWADC_TRIGGER_TIMER0ADC_TRIGGER_TIMER1... ...
	uint8_t  samp_tim;		//ADCвʱ䣬ȡֵ4--259
	uint8_t  conv_cnt;		//ADCתȡֵ1--256
	uint8_t  EOCIntEn;		//תжʹܣȡֵ01
	uint8_t *channels;		//תͨѡԪΪ ADC_CH0ADC_CH1...ADC_CH11 飬 8 ͨ 0xF ͨظ
} ADC_SEQ_InitStructure;


typedef struct {
	uint16_t UpperLimit;	//Ƚֵ
	uint16_t UpperLimitIEn;	//ADCתUpperLimitжʹ
	uint16_t LowerLimit;	//Ƚֵ
	uint16_t LowerLimitIEn;	//ADCתСLowerLimitжʹ
} ADC_CMP_InitStructure;


#define ADC_SEQ0	0x1
#define ADC_SEQ1	0x2

#define ADC_CH0		0
#define ADC_CH1		1
#define ADC_CH2		2
#define ADC_CH3		3
#define ADC_CH4		4
#define ADC_CH5		5
#define ADC_CH6		6
#define ADC_CH7		7
#define ADC_CH8		8
#define ADC_CH9		9

#define ADC_REF_VDD		(0)
#define ADC_REF_REFP	(1 | (0 << 1))
#define ADC_REF_2V4		(1 | (1 << 1) | (0 << 2))
#define ADC_REF_3V6		(1 | (1 << 1) | (1 << 2))
#define ADC_REF_4V5		(1 | (1 << 1) | (2 << 2))

#define ADC_AVG_SAMPLE1			0
#define ADC_AVG_SAMPLE2			1	//һת2ΣνƽֵΪת
#define ADC_AVG_SAMPLE4			2
#define ADC_AVG_SAMPLE8			3

#define ADC_TRIGGER_NO			0
#define ADC_TRIGGER_SW			1	//
#define ADC_TRIGGER_TIMER0		2
#define ADC_TRIGGER_TIMER1		3
#define ADC_TRIGGER_TIMER2		4
#define ADC_TRIGGER_PWM0		16
#define ADC_TRIGGER_PWM1		17


/* Interrupt Type */
#define ADC_IT_EOC			(1 << 0)	//End Of Conversion
#define ADC_IT_CMP_MAX		(1 << 1)	//תCOMP.MAX
#define ADC_IT_CMP_MIN		(1 << 2)	//תСCOMP.MIN


void ADC_Init(ADC_TypeDef * ADCx, ADC_InitStructure * initStruct);		//ADCģתʼ
void ADC_SEQ_Init(ADC_TypeDef * ADCx, uint32_t seq, ADC_SEQ_InitStructure * initStruct);	//ADCгʼ
void ADC_CMP_Init(ADC_TypeDef * ADCx, uint32_t seq, ADC_CMP_InitStructure * initStruct);	//ADCȽϹܳʼ
void ADC_Open(ADC_TypeDef * ADCx);							//ADCӲADCת
void ADC_Close(ADC_TypeDef * ADCx);							//ADCرգ޷ӲADCת
void ADC_Start(uint32_t ADC0_seq, uint32_t ADC1_seq);		//ָADCʼģת
void ADC_Stop(uint32_t ADC0_seq, uint32_t ADC1_seq);		//رָADCֹͣģת
bool ADC_Busy(ADC_TypeDef * ADCx);

uint32_t ADC_Read(ADC_TypeDef * ADCx, uint32_t chn);		//ָͨȡת
uint32_t ADC_DataAvailable(ADC_TypeDef * ADCx, uint32_t chn);			//ָͨǷݿɶȡ


void ADC_INTEn(ADC_TypeDef * ADCx, uint32_t seq, uint32_t it);
void ADC_INTEn(ADC_TypeDef * ADCx, uint32_t seq, uint32_t it);
void ADC_INTClr(ADC_TypeDef * ADCx, uint32_t seq, uint32_t it);
uint32_t ADC_INTStat(ADC_TypeDef * ADCx, uint32_t seq, uint32_t it);


#endif //__SWM221_ADC_H__
