/****************************************************************************************************************************************** 
* ļ: SWM221_can.c
* ˵:	SWM221ƬCANģ
* ֧:	http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע: 
* 汾:	V1.1.0		20171025
* ¼: 
*
*
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology
*******************************************************************************************************************************************/
#include "SWM221.h"
#include "SWM221_can.h"


/****************************************************************************************************************************************** 
* :	CAN_Init()
* ˵:	CANӿڳʼ
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*			CAN_InitStructure * initStruct    CANӿ趨ֵĽṹ
*     : 
* ע: 
******************************************************************************************************************************************/
void CAN_Init(CAN_TypeDef * CANx, CAN_InitStructure * initStruct)
{
	uint32_t brp = SystemCoreClock/2/initStruct->Baudrate/(1 + (initStruct->CAN_bs1 + 1) + (initStruct->CAN_bs2 + 1)) - 1;
	
	switch((uint32_t)CANx)
	{
	case ((uint32_t)CAN0):
		SYS->CLKEN0 |= (0x01 << SYS_CLKEN0_CAN0_Pos);
		break;
	}
	
	CAN_Close(CANx);	//һЩؼĴֻCANرʱ
	
	CANx->CR &= ~(CAN_CR_LOM_Msk | CAN_CR_STM_Msk);
	CANx->CR |= (initStruct->Mode << CAN_CR_LOM_Pos);
	
	CANx->BT1 = (0 << CAN_BT1_SAM_Pos) |
				(initStruct->CAN_bs1 << CAN_BT1_TSEG1_Pos) |
				(initStruct->CAN_bs2 << CAN_BT1_TSEG2_Pos);
	
	CANx->BT0 = (initStruct->CAN_sjw << CAN_BT0_SJW_Pos) |
				((brp & 0x3F) << CAN_BT0_BRP_Pos);
	
	CANx->BT2 = ((brp >> 6) << CAN_BT2_BRP_Pos);
	
	CANx->RXERR = 0;	//ֻڸλģʽ
	CANx->TXERR = 0;
	
	CANx->IE = (initStruct->RXNotEmptyIEn << CAN_IE_RXDA_Pos)    |
			   (initStruct->ArbitrLostIEn << CAN_IE_ARBLOST_Pos) |
			   (initStruct->ErrPassiveIEn << CAN_IE_ERRPASS_Pos);
	
	switch((uint32_t)CANx)
	{
	case ((uint32_t)CAN0):
		if(initStruct->RXNotEmptyIEn | initStruct->ArbitrLostIEn | initStruct->ErrPassiveIEn)
		{
			NVIC_EnableIRQ(CAN0_IRQn);
		}
		else
		{
			NVIC_DisableIRQ(CAN0_IRQn);
		}
		break;
	}
}

/****************************************************************************************************************************************** 
* :	CAN_Open()
* ˵:	CANӿڴ
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*     : 
* ע: 
******************************************************************************************************************************************/
void CAN_Open(CAN_TypeDef * CANx)
{
	CANx->CR &= ~(0x01 << CAN_CR_RST_Pos);	//˳λģʽ빤ģʽ
}

/****************************************************************************************************************************************** 
* :	CAN_Close()
* ˵:	CANӿڹر
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*     : 
* ע: 
******************************************************************************************************************************************/
void CAN_Close(CAN_TypeDef * CANx)
{
	CANx->CR |= (0x01 << CAN_CR_RST_Pos);	//븴λģʽܷͺͽ
}

/****************************************************************************************************************************************** 
* :	CAN_Transmit()
* ˵:	CAN
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*			uint32_t format		CAN_FRAME_STD ׼֡    CAN_FRAME_EXT չ֡
*			uint32_t id			ϢID
*			uint8_t data[]		Ҫ͵
*			uint32_t size		Ҫ͵ݵĸ
*			uint32_t once		ֻһΣʹʧܣٲöʧͳNAKҲط
*     : 
* ע: 
******************************************************************************************************************************************/
void CAN_Transmit(CAN_TypeDef * CANx, uint32_t format, uint32_t id, uint8_t data[], uint32_t size, uint32_t once)
{
	uint32_t i;
	
	if(format == CAN_FRAME_STD)
	{
		CANx->FRAME.INFO = (0 << CAN_INFO_FF_Pos)  |
							 (0 << CAN_INFO_RTR_Pos) |
							 (size << CAN_INFO_DLC_Pos);
		
		CANx->FRAME.DATA[0] = id >> 3;
		CANx->FRAME.DATA[1] = id << 5;
		
		for(i = 0; i < size; i++)
		{
			CANx->FRAME.DATA[i+2] = data[i];
		}
	}
	else //if(format == CAN_FRAME_EXT)
	{
		CANx->FRAME.INFO = (1 << CAN_INFO_FF_Pos)  |
							 (0 << CAN_INFO_RTR_Pos) |
							 (size << CAN_INFO_DLC_Pos);
		
		CANx->FRAME.DATA[0] = id >> 21;
		CANx->FRAME.DATA[1] = id >> 13;
		CANx->FRAME.DATA[2] = id >>  5;
		CANx->FRAME.DATA[3] = id <<  3;
		
		for(i = 0; i < size; i++)
		{
			CANx->FRAME.DATA[i+4] = data[i];
		}
	}
	
	if(CANx->CR & CAN_CR_STM_Msk)
	{
		CANx->CMD = (1 << CAN_CMD_SRR_Pos);
	}
	else
	{
		if(once == 0)
		{
			CANx->CMD = (1 << CAN_CMD_TXREQ_Pos);
		}
		else
		{
			CANx->CMD = (1 << CAN_CMD_TXREQ_Pos) | (1 << CAN_CMD_ABTTX_Pos);
		}
	}
}

/****************************************************************************************************************************************** 
* :	CAN_TransmitRequest()
* ˵:	CANԶԶ̽ڵ㷢
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*			uint32_t format		CAN_FRAME_STD ׼֡    CAN_FRAME_EXT չ֡
*			uint32_t id			ϢID
*			uint32_t once		ֻһΣʹʧܣٲöʧͳNAKҲط
*     : 
* ע: 
******************************************************************************************************************************************/
void CAN_TransmitRequest(CAN_TypeDef * CANx, uint32_t format, uint32_t id, uint32_t once)
{
	if(format == CAN_FRAME_STD)
	{
		CANx->FRAME.INFO = (0 << CAN_INFO_FF_Pos)  |
							 (1 << CAN_INFO_RTR_Pos) |
							 (0 << CAN_INFO_DLC_Pos);
		
		CANx->FRAME.DATA[0] = id >> 3;
		CANx->FRAME.DATA[1] = id << 5;
	}
	else //if(format == CAN_FRAME_EXT)
	{
		CANx->FRAME.INFO = (1 << CAN_INFO_FF_Pos)  |
							 (1 << CAN_INFO_RTR_Pos) |
							 (0 << CAN_INFO_DLC_Pos);
		
		CANx->FRAME.DATA[0] = id >> 21;
		CANx->FRAME.DATA[1] = id >> 13;
		CANx->FRAME.DATA[2] = id >>  5;
		CANx->FRAME.DATA[3] = id <<  3;
	}
	
	if(once == 0)
	{
		CANx->CMD = (1 << CAN_CMD_TXREQ_Pos);
	}
	else
	{
		CANx->CMD = (1 << CAN_CMD_TXREQ_Pos) | (1 << CAN_CMD_ABTTX_Pos);
	}
}

/****************************************************************************************************************************************** 
* :	CAN_Receive()
* ˵:	CAN
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*			CAN_RXMessage *msg	յϢ洢ڴ˽ṹ
*     : 
* ע: 
******************************************************************************************************************************************/
void CAN_Receive(CAN_TypeDef * CANx, CAN_RXMessage *msg)
{
	uint32_t i;
	msg->format = (CANx->FRAME.INFO & CAN_INFO_FF_Msk) >> CAN_INFO_FF_Pos;
	
	msg->remote = (CANx->FRAME.INFO & CAN_INFO_RTR_Msk) >> CAN_INFO_RTR_Pos;
	msg->size = (CANx->FRAME.INFO & CAN_INFO_DLC_Msk) >> CAN_INFO_DLC_Pos;
	
	if(msg->format == CAN_FRAME_STD)
	{
		msg->id = (CANx->FRAME.DATA[0] << 3) | (CANx->FRAME.DATA[1] >> 5);
		
		for(i = 0; i < msg->size; i++)
		{
			msg->data[i] = CANx->FRAME.DATA[i+2];
		}
	}
	else //if(msg->format == CAN_FRAME_EXT)
	{
		msg->id = (CANx->FRAME.DATA[0] << 21) | (CANx->FRAME.DATA[1] << 13) | (CANx->FRAME.DATA[2] << 5) | (CANx->FRAME.DATA[3] >> 3);
		
		for(i = 0; i < msg->size; i++)
		{
			msg->data[i] = CANx->FRAME.DATA[i+4];
		}
	}
	
	CANx->CMD = (1 << CAN_CMD_RRB_Pos);
}

/****************************************************************************************************************************************** 
* :	CAN_TXComplete()
* ˵:	Ƿ
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*     : uint32_t			1 Ѿ    0 δ
* ע: ͱAbortҲᴥɣᴥͳɹ
******************************************************************************************************************************************/
uint32_t CAN_TXComplete(CAN_TypeDef * CANx)
{
	return (CANx->SR & CAN_SR_TXBR_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	CAN_TXSuccess()
* ˵:	Ƿɹ
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*     : uint32_t			1 ͳɹ    0 ʧ
* ע: 
******************************************************************************************************************************************/
uint32_t CAN_TXSuccess(CAN_TypeDef * CANx)
{
	return (CANx->SR & CAN_SR_TXOK_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	CAN_AbortTransmit()
* ˵:	ֹ
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*     : 
* ע: ڽеķ޷ִֹдʧܲط
******************************************************************************************************************************************/
void CAN_AbortTransmit(CAN_TypeDef * CANx)
{
	CANx->CMD = (1 << CAN_CMD_ABTTX_Pos);
}

/****************************************************************************************************************************************** 
* :	CAN_TXBufferReady()
* ˵:	TX BufferǷ׼ÿдϢ
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*     : uint32_t			1 ׼    0 δ׼
* ע: 
******************************************************************************************************************************************/
uint32_t CAN_TXBufferReady(CAN_TypeDef * CANx)
{
	return (CANx->SR & CAN_SR_TXBR_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	CAN_RXDataAvailable()
* ˵:	RX FIFOǷݿɶ
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*     : uint32_t			1 ݿɶ    0 û
* ע: 
******************************************************************************************************************************************/
uint32_t CAN_RXDataAvailable(CAN_TypeDef * CANx)
{
	return (CANx->SR & CAN_SR_RXDA_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	CAN_SetBaudrate()
* ˵:	ò
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*			uint32_t baudrate	ʣλ
*			uint32_t CAN_bs1	CAN_BS1_1tqCAN_BS1_2tq... ... CAN_BS1_16tq
*			uint32_t CAN_bs2	CAN_BS2_1tqCAN_BS2_2tq... ... CAN_BS2_8tq
*			uint32_t CAN_sjw	CAN_SJW_1tqCAN_SJW_2tqCAN_SJW_3tqCAN_SJW_4tq
*     : 
* ע: ǰҪȵCAN_Close()رCANģ
******************************************************************************************************************************************/
void CAN_SetBaudrate(CAN_TypeDef * CANx, uint32_t baudrate, uint32_t CAN_bs1, uint32_t CAN_bs2, uint32_t CAN_sjw)
{
	uint32_t brp = SystemCoreClock/2/baudrate/(1 + (CAN_bs1 + 1) + (CAN_bs2 + 1)) - 1;
	
	CANx->BT1 = (0 << CAN_BT1_SAM_Pos) |
				(CAN_bs1 << CAN_BT1_TSEG1_Pos) |
				(CAN_bs2 << CAN_BT1_TSEG2_Pos);
	
	CANx->BT0 = (CAN_sjw << CAN_BT0_SJW_Pos) |
				((brp & 0x3F) << CAN_BT0_BRP_Pos);
	
	CANx->BT2 = ((brp >> 6) << CAN_BT2_BRP_Pos);
}

/****************************************************************************************************************************************** 
* :	CAN_SetFilter32b()
* ˵:	ý˲ģʽΪ132λ˲
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*			uint32_t filter		Ҫõ˲ЧֵCAN_FILTER_1CAN_FILTER_2...CAN_FILTER_16
*			uint32_t check		maskһ˽յMessageǷԼҪģcheck & mask == ID & maskMessageͨ
*			uint32_t mask
*     : 
* ע: ֻڹرʱ
******************************************************************************************************************************************/
void CAN_SetFilter32b(CAN_TypeDef * CANx, uint32_t filter, uint32_t check, uint32_t mask)
{	
	CANx->AFM |= (1 << filter);
	
	CANx->ACR[filter] = __REV(check << 3);		// 29λ
	CANx->AMR[filter] = __REV(~(mask << 3));
	
	CANx->AFE |= (1 << filter);
}

/****************************************************************************************************************************************** 
* :	CAN_SetFilter16b()
* ˵:	ý˲ģʽΪ216λ˲
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*			uint32_t filter		Ҫõ˲ЧֵCAN_FILTER_1CAN_FILTER_2...CAN_FILTER_16
*			uint16_t check1		maskһ˽յMessageǷԼҪģcheck & mask == ID & maskMessageͨ
*			uint16_t mask1
*			uint16_t check2
*			uint16_t mask2
*     : 
* ע: ֻڹرʱ
******************************************************************************************************************************************/
void CAN_SetFilter16b(CAN_TypeDef * CANx, uint32_t filter, uint16_t check1, uint16_t mask1, uint16_t check2, uint16_t mask2)
{
	CANx->AFM &= ~(1 << filter);
	
	CANx->ACR[filter] = __REV((check1 << 5) | (check2 << 21));		// 11λ
	CANx->AMR[filter] = __REV(~((mask1 << 5) | (mask2 << 21)));
	
	CANx->AFE |= (1 << filter);
}

/****************************************************************************************************************************************** 
* :	CAN_INTEn()
* ˵:	ʹָж
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*			uint32_t it			interrupt typeЧֵ CAN_IT_RX_NOTEMPTYCAN_IT_RX_OVERFLOWCAN_IT_TX_EMPTYCAN_IT_ARBLOST
*								CAN_IT_ERRCAN_IT_ERR_WARNCAN_IT_ERR_PASSCAN_IT_WAKEUP 䡰
*     : 
* ע: 
******************************************************************************************************************************************/
void CAN_INTEn(CAN_TypeDef * CANx, uint32_t it)
{
	CANx->IE |= it;
}

/****************************************************************************************************************************************** 
* :	CAN_INTDis()
* ˵:	رָж
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*			uint32_t it			interrupt typeЧֵ CAN_IT_RX_NOTEMPTYCAN_IT_RX_OVERFLOWCAN_IT_TX_EMPTYCAN_IT_ARBLOST
*								CAN_IT_ERRCAN_IT_ERR_WARNCAN_IT_ERR_PASSCAN_IT_WAKEUP 䡰
*     : 
* ע: 
******************************************************************************************************************************************/
void CAN_INTDis(CAN_TypeDef * CANx, uint32_t it)
{
	CANx->IE &= ~it;
}

/****************************************************************************************************************************************** 
* :	CAN_INTClr()
* ˵:	жϱ־
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*			uint32_t it			interrupt typeЧֵ CAN_IT_RX_OVERFLOW
*     : 
* ע: 
******************************************************************************************************************************************/
void CAN_INTClr(CAN_TypeDef * CANx, uint32_t it)
{
	CANx->CMD = (1 << CAN_CMD_CLROV_Pos);
}

/****************************************************************************************************************************************** 
* :	CAN_INTStat()
* ˵:	ѯж״̬
*     : CAN_TypeDef * CANx	ָҪõCANӿڣЧֵCAN0
*     : uint32_t			ǰж״̬
* ע: CANx->IFȡ㣬жISRֻܶȡһΣܶζȡ
******************************************************************************************************************************************/
uint32_t CAN_INTStat(CAN_TypeDef * CANx)
{
	return CANx->IF;
}
