#ifndef __SWM221_DIV_H__
#define __SWM221_DIV_H__


void DIV_Init(DIV_TypeDef * DIVx);


/****************************************************************************************************************************************** 
* :	DIV_UDiv()
* ˵:	ʹӲִ޷
*     : uint32_t dividend		
*			uint32_t divisor		
*     : 
* ע: 
******************************************************************************************************************************************/
static __INLINE void DIV_UDiv(uint32_t dividend, uint32_t divisor)
{
	DIV->DIVIDEND = dividend;
	DIV->DIVISOR = divisor;
	
	DIV->CR = (1 << DIV_CR_DIVSIGN_Pos) | (1 << DIV_CR_DIVGO_Pos);
}

/****************************************************************************************************************************************** 
* :	DIV_SDiv()
* ˵:	ʹӲִз
*     : int32_t dividend		
*			int32_t divisor			
*     : 
* ע: 
******************************************************************************************************************************************/
static __INLINE void DIV_SDiv(int32_t dividend, int32_t divisor)
{
	DIV->DIVIDEND = dividend;
	DIV->DIVISOR = divisor;
	
	DIV->CR = (0 << DIV_CR_DIVSIGN_Pos) | (1 << DIV_CR_DIVGO_Pos);
}

/****************************************************************************************************************************************** 
* :	DIV_Div_IsBusy()
* ˵:	ӲǷִг
*     : 
*     : uint32_t		1 Ӳִг    0 Ӳɳ㣬ȡ
* ע: 
******************************************************************************************************************************************/
static __INLINE uint32_t DIV_Div_IsBusy(void)
{
	return (DIV->SR & DIV_SR_DIVBUSY_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	DIV_UDiv_Result()
* ˵:	ȡӲ
*     : 
*     : uint32_t *quotient		
*			uint32_t *remainder		
* ע: 
******************************************************************************************************************************************/
static __INLINE void DIV_UDiv_Result(uint32_t *quotient, uint32_t *remainder)
{
	*quotient = DIV->QUO;
	*remainder = DIV->REMAIN;
}

/****************************************************************************************************************************************** 
* :	DIV_SDiv_Result()
* ˵:	ȡӲ
*     : 
*     : int32_t *quotient		
*			int32_t *remainder		
* ע: 
******************************************************************************************************************************************/
static __INLINE void DIV_SDiv_Result(int32_t *quotient, int32_t *remainder)
{
	*quotient = DIV->QUO & 0x7FFFFFFF;
	if(DIV->QUO & (1u << 31)) *quotient = 0 - *quotient;
	
	*remainder = DIV->REMAIN & 0x7FFFFFFF;
	if(DIV->REMAIN & (1u << 31)) *remainder = 0 - *remainder;
}

/****************************************************************************************************************************************** 
* :	DIV_Root()
* ˵:	ʹӲģִп
*     : uint32_t radicand		
*			uint32_t calcu_frac		0 Ϊ16λ    1 Ϊ16λ+16λС
*     : 
* ע: 
******************************************************************************************************************************************/
static __INLINE void DIV_Root(uint32_t radicand, uint32_t calcu_fractional)
{
	DIV->RADICAND = radicand;
	
	DIV->CR = (1 << DIV_CR_ROOTGO_Pos) | (calcu_fractional << DIV_CR_ROOTMOD_Pos);
}

/****************************************************************************************************************************************** 
* :	DIV_Root_IsBusy()
* ˵:	ӲģǷִп
*     : 
*     : uint32_t		1 Ӳģִп    0 Ӳģɿ㣬ȡ
* ע: 
******************************************************************************************************************************************/
static __INLINE uint32_t DIV_Root_IsBusy(void)
{
	return (DIV->SR & DIV_SR_ROOTBUSY_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	DIV_Root_Result()
* ˵:	ȡӲģ
*     : 
*     : uint32_t		
* ע: 
******************************************************************************************************************************************/
static __INLINE uint32_t DIV_Root_Result(void)
{
	if(DIV->CR & DIV_CR_ROOTMOD_Msk)
	{
		return DIV->ROOT;
	}
	else
	{
		return DIV->ROOT >> 16;
	}
}

#endif //__SWM221_DIV_H__
