/****************************************************************************************************************************************** 
* ļ:	SWM221_exti.c
* ˵:	SWM221ƬⲿжϹ
* ֧: http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע:
* 汾: V1.0.0		2016130
* ¼:  
*
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology 
*******************************************************************************************************************************************/
#include "SWM221.h"
#include "SWM221_exti.h"


/****************************************************************************************************************************************** 
* : EXTI_Init()
* ˵:	ָⲿжϳʼ
*     : GPIO_TypeDef * GPIOx	ָⲿжϵGPIO˿ڣЧֵGPIOAGPIOBGPIOC
*			uint32_t n 		   ָⲿжϵGPIOţЧֵPIN0PIN1PIN2... ... PIN14PIN15
*			uint32_t mode	   ЧֵEXTI_FALL_EDGEEXTI_RISE_EDGEEXTI_BOTH_EDGEEXTI_LOW_LEVELEXTI_HIGH_LEVEL
*     : 
* ע: 
******************************************************************************************************************************************/
void EXTI_Init(GPIO_TypeDef * GPIOx, uint32_t n, uint32_t mode)
{
	EXTI_Close(GPIOx, n);			//ùؼĴǰȹر
	
	if(mode & 0x10)
	{
		GPIOx->INTLVLTRG |= (0x01 << n);			//ƽ
		
		if(mode & 0x01)
			GPIOx->INTRISEEN |= (0x01 << n);				//ߵƽ
		else
			GPIOx->INTRISEEN &= ~(0x01 << n);				//͵ƽ
	}		
	else
	{
		GPIOx->INTLVLTRG &= ~(0x01 << n);			//ش
		
		if(mode & 0x02)
		{
			GPIOx->INTBE |= (0x01 << n);				//˫ش	
		}
		else
		{
			GPIOx->INTBE &= ~(0x01 << n);				//ش
			
			if(mode & 0x01)
				GPIOx->INTRISEEN |= (0x01 << n);			//ش
			else
				GPIOx->INTRISEEN &= ~(0x01 << n);			//½ش
		}
	}
	
	GPIOx->INTCLR = (1 << n);		//Ϊģʽÿܲж
}

/****************************************************************************************************************************************** 
* :	EXTI_Open()
* ˵:	ָⲿжϴ򿪣ʹܣ
*     : GPIO_TypeDef * GPIOx	ָⲿжϵGPIO˿ڣЧֵGPIOAGPIOBGPIOC
*			uint32_t n 		   ָⲿжϵGPIOţЧֵPIN0PIN1PIN2... ... PIN14PIN15
*     : 
* ע: 
******************************************************************************************************************************************/
void EXTI_Open(GPIO_TypeDef * GPIOx, uint32_t n)
{
	GPIOx->INTEN |= (0x01 << n);
}

/****************************************************************************************************************************************** 
* :	EXTI_Close()
* ˵:	ָⲿжϹرգܣ
*     : GPIO_TypeDef * GPIOx	ָⲿжϵGPIO˿ڣЧֵGPIOAGPIOBGPIOC
*			uint32_t n 		   ָⲿжϵGPIOţЧֵPIN0PIN1PIN2... ... PIN14PIN15
*     : 
* ע: 
******************************************************************************************************************************************/
void EXTI_Close(GPIO_TypeDef * GPIOx, uint32_t n)
{
	GPIOx->INTEN &= ~(0x01 << n);
}

/****************************************************************************************************************************************** 
* :	EXTI_State()
* ˵:	ָǷ񴥷ж
*     : GPIO_TypeDef * GPIOx	ָⲿжϵGPIO˿ڣЧֵGPIOAGPIOBGPIOC
*			uint32_t n 		   ָⲿжϵGPIOţЧֵPIN0PIN1PIN2... ... PIN14PIN15
*     : uint32_t	1 Ŵж    0 δж
* ע: 
******************************************************************************************************************************************/
uint32_t EXTI_State(GPIO_TypeDef * GPIOx, uint32_t n)
{
	return (GPIOx->INTSTAT >> n) & 0x01;
}

/****************************************************************************************************************************************** 
* :	EXTI_RawState()
* ˵:	ָǷ/жϴжϹرʱͨô˺ԲѯķʽǷ/жϴ
*     : GPIO_TypeDef * GPIOx	ָⲿжϵGPIO˿ڣЧֵGPIOAGPIOBGPIOC
*			uint32_t n 		   ָⲿжϵGPIOţЧֵPIN0PIN1PIN2... ... PIN14PIN15
*     : uint32_t	1 /жϴ    0 δ/жϴ
* ע: 
******************************************************************************************************************************************/
uint32_t EXTI_RawState(GPIO_TypeDef * GPIOx, uint32_t n)
{
	return (GPIOx->INTRAWSTAT >> n) & 0x01;
}

/****************************************************************************************************************************************** 
* :	EXTI_Clear()
* ˵:	ָⲿжжϱ־ٴνжϣ
*     : GPIO_TypeDef * GPIOx	ָⲿжϵGPIO˿ڣЧֵGPIOAGPIOBGPIOC
*			uint32_t n 		   ָⲿжϵGPIOţЧֵPIN0PIN1PIN2... ... PIN14PIN15
*     : 
* ע: ֻشжϵı־ƽжϵı־޷ֻŵƽжϴӲԶ
******************************************************************************************************************************************/
void EXTI_Clear(GPIO_TypeDef * GPIOx, uint32_t n)
{
	GPIOx->INTCLR = (0x01 << n);
}
