/****************************************************************************************************************************************** 
* ļ: SWM221_timr.c
* ˵:	SWM221Ƭļ/ʱ
* ֧:	http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע:
* 汾:	V1.0.0		2016130
* ¼: 
*
*
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology 
*******************************************************************************************************************************************/
#include "SWM221.h"
#include "SWM221_timr.h"


/****************************************************************************************************************************************** 
* : TIMR_Init()
* ˵:	TIMRʱ/ʼ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱЧֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*			uint32_t mode			TIMR0~3: TIMR_MODE_TIMERTIMR_MODE_COUNTERTIMR_MODE_OCTIMR_MODE_IC
*									BTIMR0~3: TIMR_MODE_TIMERTIMR_MODE_OC
*			uint32_t prediv			ԤƵȡֵ1-256
*			uint32_t period			ʱ/ڣȡֵ1-16777216
*			uint32_t int_en			жʹ
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_Init(TIMR_TypeDef * TIMRx, uint32_t mode, uint32_t prediv, uint32_t period, uint32_t int_en)
{	
	if((TIMRx == TIMR0) || (TIMRx == TIMR1) || (TIMRx == TIMR2))
	{
		SYS->CLKEN0 |= (0x01 << SYS_CLKEN0_TIMR_Pos);
	}
	else if((TIMRx == BTIMR0) || (TIMRx == BTIMR1) || (TIMRx == BTIMR2) || (TIMRx == BTIMR3))
	{
		SYS->CLKEN0 |= (0x01 << SYS_CLKEN0_BTIMR_Pos);
	}
	
	TIMR_Stop(TIMRx);	//һЩؼĴֻڶʱֹͣʱ
	
	TIMRx->CR &= ~(TIMR_CR_MODE_Msk | TIMR_CR_CLKSRC_Msk);
	TIMRx->CR |= (mode << TIMR_CR_CLKSRC_Pos);

	TIMRx->PREDIV = prediv - 1;
	
	TIMRx->LOAD = period - 1;
	
	TIMRx->IF = (1 << TIMR_IF_TO_Pos);		//жϱ־
	if(int_en) TIMRx->IE |=  (1 << TIMR_IE_TO_Pos);
	else	   TIMRx->IE &= ~(1 << TIMR_IE_TO_Pos);
	
	switch((uint32_t)TIMRx)
	{
	case ((uint32_t)TIMR0):
		if(int_en) NVIC_EnableIRQ(TIMR0_IRQn);
		break;
	
	case ((uint32_t)TIMR1):
		if(int_en) NVIC_EnableIRQ(TIMR1_IRQn);
		break;
	
	case ((uint32_t)TIMR2):
		if(int_en) NVIC_EnableIRQ(GPIOB0_GPIOA8_TIMR2_IRQn);
		break;
	
	case ((uint32_t)BTIMR0):
		if(int_en) NVIC_EnableIRQ(BTIMR0_IRQn);
		break;
	
	case ((uint32_t)BTIMR1):
		if(int_en) NVIC_EnableIRQ(BTIMR1_IRQn);
		break;
	
	case ((uint32_t)BTIMR2):
		if(int_en) NVIC_EnableIRQ(BTIMR2_IRQn);
		break;
	
	case ((uint32_t)BTIMR3):
		if(int_en) NVIC_EnableIRQ(BTIMR3_IRQn);
		break;
	}
}

/****************************************************************************************************************************************** 
* :	TIMR_Start()
* ˵:	ʱӳʼֵʼʱ/
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_Start(TIMR_TypeDef * TIMRx)
{
	switch((uint32_t)TIMRx)
	{
	case ((uint32_t)TIMR0):
		TIMRG->EN |= (1 << TIMRG_EN_TIMR0_Pos);
		break;
	
	case ((uint32_t)TIMR1):
		TIMRG->EN |= (1 << TIMRG_EN_TIMR1_Pos);
		break;
	
	case ((uint32_t)TIMR2):
		TIMRG->EN |= (1 << TIMRG_EN_TIMR2_Pos);
		break;
	
	case ((uint32_t)BTIMR0):
		BTIMRG->EN |= (1 << TIMRG_EN_TIMR0_Pos);
		break;
	
	case ((uint32_t)BTIMR1):
		BTIMRG->EN |= (1 << TIMRG_EN_TIMR1_Pos);
		break;
	
	case ((uint32_t)BTIMR2):
		BTIMRG->EN |= (1 << TIMRG_EN_TIMR2_Pos);
		break;
	
	case ((uint32_t)BTIMR3):
		BTIMRG->EN |= (1 << TIMRG_EN_TIMR3_Pos);
		break;
	}
}

/****************************************************************************************************************************************** 
* :	TIMR_Stop()
* ˵:	ֹͣʱ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_Stop(TIMR_TypeDef * TIMRx)
{
	switch((uint32_t)TIMRx)
	{
	case ((uint32_t)TIMR0):
		TIMRG->EN &= ~(1 << TIMRG_EN_TIMR0_Pos);
		break;
	
	case ((uint32_t)TIMR1):
		TIMRG->EN &= ~(1 << TIMRG_EN_TIMR1_Pos);
		break;
	
	case ((uint32_t)TIMR2):
		TIMRG->EN &= ~(1 << TIMRG_EN_TIMR2_Pos);
		break;
	
	case ((uint32_t)BTIMR0):
		BTIMRG->EN &= ~(1 << TIMRG_EN_TIMR0_Pos);
		break;
	
	case ((uint32_t)BTIMR1):
		BTIMRG->EN &= ~(1 << TIMRG_EN_TIMR1_Pos);
		break;
	
	case ((uint32_t)BTIMR2):
		BTIMRG->EN &= ~(1 << TIMRG_EN_TIMR2_Pos);
		break;
	
	case ((uint32_t)BTIMR3):
		BTIMRG->EN &= ~(1 << TIMRG_EN_TIMR3_Pos);
		break;
	}
}

/****************************************************************************************************************************************** 
* :	TIMR_Halt()
* ˵:	ͣʱֲֵ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_Halt(TIMR_TypeDef * TIMRx)
{
	TIMRx->HALT = 1;
}

/****************************************************************************************************************************************** 
* :	TIMR_Resume()
* ˵:	ָʱͣ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_Resume(TIMR_TypeDef * TIMRx)
{
	TIMRx->HALT = 0;
}

/****************************************************************************************************************************************** 
* :	TIMR_GetCurValue()
* ˵:	ȡǰֵ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : uint32_t				ǰֵ
* ע: 
******************************************************************************************************************************************/
uint32_t TIMR_GetCurValue(TIMR_TypeDef * TIMRx)
{
	return TIMRx->VALUE;
}

/****************************************************************************************************************************************** 
* :	TIMR_INTEn()
* ˵:	ʹж
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_INTEn(TIMR_TypeDef * TIMRx)
{
	TIMRx->IE |= (1 << TIMR_IE_TO_Pos);
}

/****************************************************************************************************************************************** 
* : TIMR_INTDis()
* ˵:	ж
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_INTDis(TIMR_TypeDef * TIMRx)
{
	TIMRx->IE &= ~(1 << TIMR_IE_TO_Pos);
}

/****************************************************************************************************************************************** 
* :	TIMR_INTClr()
* ˵:	жϱ־
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_INTClr(TIMR_TypeDef * TIMRx)
{
	TIMRx->IF = (1 << TIMR_IF_TO_Pos);
}

/****************************************************************************************************************************************** 
* : TIMR_INTStat()
* ˵:	ȡж״̬
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : uint32_t 				0 TIMRxδж    1 TIMRxж
* ע: 
******************************************************************************************************************************************/
uint32_t TIMR_INTStat(TIMR_TypeDef * TIMRx)
{
	return (TIMRx->IF & TIMR_IF_TO_Msk) ? 1 : 0;
}


/****************************************************************************************************************************************** 
* : TIMR_OC_Init()
* ˵:	ȽϹܳʼ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*			uint32_t match			ֵݼmatchʱƽת
*			uint32_t match_int_en	ֵݼmatchʱǷж
*			uint32_t init_lvl		ʼƽTimerֹͣʱģʽǡȽϡʱƽ
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_OC_Init(TIMR_TypeDef * TIMRx, uint32_t match, uint32_t match_int_en, uint32_t init_lvl)
{
	TIMRx->OCMAT = match;
	if(init_lvl) TIMRx->OCCR |=  (1 << TIMR_OCCR_INITLVL_Pos);
	else         TIMRx->OCCR &= ~(1 << TIMR_OCCR_INITLVL_Pos);
	
	TIMRx->IF = (1 << TIMR_IF_OC0_Pos);		//жϱ־
	if(match_int_en) TIMRx->IE |=  (1 << TIMR_IE_OC0_Pos);
	else             TIMRx->IE &= ~(1 << TIMR_IE_OC0_Pos);
	
	switch((uint32_t)TIMRx)
	{
	case ((uint32_t)TIMR0):
		if(match_int_en) NVIC_EnableIRQ(TIMR0_IRQn);
		break;
	
	case ((uint32_t)TIMR1):
		if(match_int_en) NVIC_EnableIRQ(TIMR1_IRQn);
		break;

	case ((uint32_t)TIMR2):
		if(match_int_en) NVIC_EnableIRQ(GPIOB0_GPIOA8_TIMR2_IRQn);
		break;
	
	case ((uint32_t)BTIMR0):
		if(match_int_en) NVIC_EnableIRQ(BTIMR0_IRQn);
		break;
	
	case ((uint32_t)BTIMR1):
		if(match_int_en) NVIC_EnableIRQ(BTIMR1_IRQn);
		break;
	
	case ((uint32_t)BTIMR2):
		if(match_int_en) NVIC_EnableIRQ(BTIMR2_IRQn);
		break;
	
	case ((uint32_t)BTIMR3):
		if(match_int_en) NVIC_EnableIRQ(BTIMR3_IRQn);
		break;
	}
}

/****************************************************************************************************************************************** 
* :	TIMR_OC_OutputEn()
* ˵:	ʹȽϹܵĲ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_OC_OutputEn(TIMR_TypeDef * TIMRx)
{
	TIMRx->OCCR &= ~(TIMR_OCCR_FORCEEN_Pos);
}

/****************************************************************************************************************************************** 
* :	TIMR_OC_OutputDis()
* ˵:	ֹȽϹܵĲȽϹűlevelƽ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*			uint32_t level			ֹκϱֵĵƽ
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_OC_OutputDis(TIMR_TypeDef * TIMRx, uint32_t level)
{
	if(level) TIMRx->OCCR |=  (1 << TIMR_OCCR_FORCELVL_Pos);
	else      TIMRx->OCCR &= ~(1 << TIMR_OCCR_FORCELVL_Pos);
	
	TIMRx->OCCR |= (TIMR_OCCR_FORCEEN_Pos);
}

/****************************************************************************************************************************************** 
* : TIMR_OC_SetMatch()
* ˵:	ȽϹܵıȽֵ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*			uint32_t match			ȽϹܵıȽֵ
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_OC_SetMatch(TIMR_TypeDef * TIMRx, uint32_t match)
{
	TIMRx->OCMAT = match;
}

/****************************************************************************************************************************************** 
* : TIMR_OC_GetMatch()
* ˵:	ȡȽϹܵıȽֵ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : uint32_t				ȽϹܵıȽֵ
* ע: 
******************************************************************************************************************************************/
uint32_t TIMR_OC_GetMatch(TIMR_TypeDef * TIMRx)
{	
	return TIMRx->OCMAT;
}

/****************************************************************************************************************************************** 
* :	TIMR_OC_INTEn()
* ˵:	ʹȽж
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_OC_INTEn(TIMR_TypeDef * TIMRx)
{
	TIMRx->IE |= (1 << TIMR_IE_OC0_Pos);
}

/****************************************************************************************************************************************** 
* : TIMR_OC_INTDis()
* ˵:	Ƚж
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_OC_INTDis(TIMR_TypeDef * TIMRx)
{
	TIMRx->IE &= ~(1 << TIMR_IE_OC0_Pos);
}

/****************************************************************************************************************************************** 
* :	TIMR_OC_INTClr()
* ˵:	Ƚжϱ־
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_OC_INTClr(TIMR_TypeDef * TIMRx)
{
	TIMRx->IF = (1 << TIMR_IF_OC0_Pos);
}

/****************************************************************************************************************************************** 
* : TIMR_OC_INTStat()
* ˵:	ȡȽж״̬
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2BTIMR0BTIMR1BTIMR2BTIMR3
*     : uint32_t 				0 Ƚmatchδ   1 Ƚmatch
* ע: 
******************************************************************************************************************************************/
uint32_t TIMR_OC_INTStat(TIMR_TypeDef * TIMRx)
{
	return (TIMRx->IF & TIMR_IF_OC0_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* : TIMR_IC_Init()
* ˵:	벶ܳʼ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*			uint32_t captureH_int_en	ߵƽжʹ
*			uint32_t captureL_int_en	͵ƽжʹ
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_IC_Init(TIMR_TypeDef * TIMRx, uint32_t captureH_int_en, uint32_t captureL_int_en)
{
	TIMRx->IF = (TIMR_IF_ICR_Msk | TIMR_IF_ICF_Msk);
	if(captureH_int_en) TIMRx->IE |=  (1 << TIMR_IE_ICF_Pos);
	else                TIMRx->IE &= ~(1 << TIMR_IE_ICF_Pos);
	if(captureL_int_en) TIMRx->IE |=  (1 << TIMR_IE_ICR_Pos);
	else                TIMRx->IE &= ~(1 << TIMR_IE_ICR_Pos);
	
	switch((uint32_t)TIMRx)
	{
	case ((uint32_t)TIMR0):
		if(captureH_int_en | captureL_int_en) NVIC_EnableIRQ(TIMR0_IRQn);
		break;
	
	case ((uint32_t)TIMR1):
		if(captureH_int_en | captureL_int_en) NVIC_EnableIRQ(TIMR1_IRQn);
		break;

	case ((uint32_t)TIMR2):
		if(captureH_int_en | captureL_int_en) NVIC_EnableIRQ(GPIOB0_GPIOA8_TIMR2_IRQn);
		break;
	}
}

/****************************************************************************************************************************************** 
* : TIMR_IC_GetCaptureH()
* ˵:	ȡߵƽȲ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*     : uint32_t				ߵƽȲ
* ע: 
******************************************************************************************************************************************/
uint32_t TIMR_IC_GetCaptureH(TIMR_TypeDef * TIMRx)
{
	return TIMRx->ICHIGH;
}

/****************************************************************************************************************************************** 
* : TIMR_IC_GetCaptureL()
* ˵:	ȡ͵ƽȲ
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*     : uint32_t				͵ƽȲ
* ע: 
******************************************************************************************************************************************/
uint32_t TIMR_IC_GetCaptureL(TIMR_TypeDef * TIMRx)
{
	return TIMRx->ICLOW;
}

/****************************************************************************************************************************************** 
* :	TIMR_IC_CaptureH_INTEn()
* ˵:	ʹ벶ߵƽȲж
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_IC_CaptureH_INTEn(TIMR_TypeDef * TIMRx)
{
	TIMRx->IE |= (1 << TIMR_IE_ICF_Pos);
}

/****************************************************************************************************************************************** 
* : TIMR_IC_CaptureH_INTDis()
* ˵:	벶ߵƽȲж
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_IC_CaptureH_INTDis(TIMR_TypeDef * TIMRx)
{
	TIMRx->IE &= ~(1 << TIMR_IE_ICF_Pos);
}

/****************************************************************************************************************************************** 
* :	TIMR_IC_CaptureH_INTClr()
* ˵:	벶ߵƽȲжϱ־
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_IC_CaptureH_INTClr(TIMR_TypeDef * TIMRx)
{
	TIMRx->IF = (1 << TIMR_IF_ICF_Pos);
}

/****************************************************************************************************************************************** 
* : TIMR_IC_CaptureH_INTStat()
* ˵:	ȡ벶ߵƽȲж״̬
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*     : uint32_t 				0 ߵƽȲδ    1 ߵƽȲ
* ע: 
******************************************************************************************************************************************/
uint32_t TIMR_IC_CaptureH_INTStat(TIMR_TypeDef * TIMRx)
{
	return (TIMRx->IF & TIMR_IF_ICF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	TIMR_IC_CaptureL_INTEn()
* ˵:	ʹ벶͵ƽȲж
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_IC_CaptureL_INTEn(TIMR_TypeDef * TIMRx)
{
	TIMRx->IE |= (1 << TIMR_IE_ICR_Pos);
}

/****************************************************************************************************************************************** 
* : TIMR_IC_CaptureL_INTDis()
* ˵:	벶͵ƽȲж
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_IC_CaptureL_INTDis(TIMR_TypeDef * TIMRx)
{
	TIMRx->IE &= ~(1 << TIMR_IE_ICR_Pos);
}

/****************************************************************************************************************************************** 
* :	TIMR_IC_CaptureL_INTClr()
* ˵:	벶͵ƽȲжϱ־
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*     : 
* ע: 
******************************************************************************************************************************************/
void TIMR_IC_CaptureL_INTClr(TIMR_TypeDef * TIMRx)
{
	TIMRx->IF = (1 << TIMR_IF_ICR_Pos);
}

/****************************************************************************************************************************************** 
* : TIMR_IC_CaptureL_INTStat()
* ˵:	ȡ벶͵ƽȲж״̬
*     : TIMR_TypeDef * TIMRx	ָҪõĶʱȡֵTIMR0TIMR1TIMR2
*     : uint32_t 				0 ͵ƽȲδ    1 ͵ƽȲ
* ע: 
******************************************************************************************************************************************/
uint32_t TIMR_IC_CaptureL_INTStat(TIMR_TypeDef * TIMRx)
{
	return (TIMRx->IF & TIMR_IF_ICR_Msk) ? 1 : 0;
}
