/****************************************************************************************************************************************** 
* ļ:	SWM221_uart.c
* ˵:	SWM221ƬUARTڹ
* ֧:	http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע: 
* 汾:	V1.0.0		2016130
* ¼: 
*
*
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology 
*******************************************************************************************************************************************/
#include "SWM221.h"
#include "SWM221_uart.h"


/****************************************************************************************************************************************** 
* :	UART_Init()
* ˵:	UARTڳʼ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*			UART_InitStructure * initStruct    UART趨ֵĽṹ
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_Init(UART_TypeDef * UARTx, UART_InitStructure * initStruct)
{	
	switch((uint32_t)UARTx)
	{
	case ((uint32_t)UART0):
		SYS->CLKEN0 |= (0x01 << SYS_CLKEN0_UART0_Pos);
		break;
	
	case ((uint32_t)UART1):
		SYS->CLKEN0 |= (0x01 << SYS_CLKEN0_UART1_Pos);
		break;
	}
	
	UART_Close(UARTx);	//һЩؼĴֻڴڹرʱ
	
	UARTx->BAUD &= ~(UART_BAUD_BAUD_Msk | UART_BAUD_FRAC_Msk);
	UARTx->BAUD |= (((SystemCoreClock/initStruct->Baudrate - 1) / 16) << UART_BAUD_BAUD_Pos) |
				   (((SystemCoreClock/initStruct->Baudrate - 1) % 16) << UART_BAUD_FRAC_Pos);
	
	UARTx->CTRL &= ~(UART_CTRL_DATA9b_Msk | UART_CTRL_PARITY_Msk | UART_CTRL_STOP2b_Msk);
	UARTx->CTRL |= (initStruct->DataBits << UART_CTRL_DATA9b_Pos) |
				   (initStruct->Parity   << UART_CTRL_PARITY_Pos) |
				   (initStruct->StopBits << UART_CTRL_STOP2b_Pos);
	
	UARTx->FIFO &= ~(UART_FIFO_RXTHR_Msk | UART_FIFO_TXTHR_Msk);
	UARTx->FIFO |= (initStruct->RXThreshold << UART_FIFO_RXTHR_Pos) | 
				   (initStruct->TXThreshold << UART_FIFO_TXTHR_Pos);
	
	UARTx->TOCR &= ~UART_TOCR_TIME_Msk;
	UARTx->TOCR |= (1 << UART_TOCR_MODE_Pos) |
				   (initStruct->TimeoutTime << UART_TOCR_TIME_Pos);
	
	UARTx->CTRL &= ~(UART_CTRL_RXIE_Msk | UART_CTRL_TXIE_Msk | UART_CTRL_TOIE_Msk);
	UARTx->CTRL |= (initStruct->RXThresholdIEn << UART_CTRL_RXIE_Pos) |
				   (initStruct->TXThresholdIEn << UART_CTRL_TXIE_Pos) |
				   (initStruct->TimeoutIEn << UART_CTRL_TOIE_Pos);
	
	switch((uint32_t)UARTx)
	{
	case ((uint32_t)UART0):		
		if(initStruct->RXThresholdIEn | initStruct->TXThresholdIEn | initStruct->TimeoutIEn)
		{
			NVIC_EnableIRQ(UART0_IRQn);
		}
		else
		{
			NVIC_DisableIRQ(UART0_IRQn);
		}
		break;
	
	case ((uint32_t)UART1):		
		if(initStruct->RXThresholdIEn | initStruct->TXThresholdIEn | initStruct->TimeoutIEn)
		{
			NVIC_EnableIRQ(UART1_IRQn);
		}
		else
		{
			NVIC_DisableIRQ(UART1_IRQn);
		}
		break;
	}
}

/****************************************************************************************************************************************** 
* :	UART_Open()
* ˵:	UARTڴ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_Open(UART_TypeDef * UARTx)
{
	UARTx->CTRL |= (0x01 << UART_CTRL_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_Close()
* ˵:	UARTڹر
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_Close(UART_TypeDef * UARTx)
{
	UARTx->CTRL &= ~(0x01 << UART_CTRL_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_WriteByte()
* ˵:	һֽ
*     : UART_TypeDef * UARTx	ָҪõUARTڣȡֵUART0UART1UART4
*			uint8_t data			Ҫ͵ֽ			
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_WriteByte(UART_TypeDef * UARTx, uint8_t data)
{
	UARTx->DATA = data;
}

/****************************************************************************************************************************************** 
* :	UART_ReadByte()
* ˵:	ȡһֽݣָǷValid
*     : UART_TypeDef * UARTx	ָҪõUARTڣȡֵUART0UART1UART4
*			uint32_t * data			յ
*     : uint32_t				0 ޴    UART_ERR_PARITY żУ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_ReadByte(UART_TypeDef * UARTx, uint32_t * data)
{
	uint32_t reg = UARTx->DATA;
	
	*data = (reg & UART_DATA_DATA_Msk);
	
	if(reg & UART_DATA_PAERR_Msk) return UART_ERR_PARITY;
	
	return 0;
}

/****************************************************************************************************************************************** 
* :	UART_IsTXBusy()
* ˵:	UARTǷڷ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*     : uint32_t				1 UARTڷ    0 ѷ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_IsTXBusy(UART_TypeDef * UARTx)
{
	return (UARTx->CTRL & UART_CTRL_TXIDLE_Msk) ? 0 : 1;
}

/****************************************************************************************************************************************** 
* :	UART_IsRXFIFOEmpty()
* ˵:	FIFOǷΪգ˵ݿԶȡ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*     : uint32_t				1 FIFO    0 FIFOǿ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_IsRXFIFOEmpty(UART_TypeDef * UARTx)
{
	return (UARTx->CTRL & UART_CTRL_RXNE_Msk) ? 0 : 1;
}

/****************************************************************************************************************************************** 
* :	UART_IsTXFIFOFull()
* ˵:	FIFOǷΪԼд
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*     : uint32_t				1 FIFO    0 FIFO
* ע: 
******************************************************************************************************************************************/
uint32_t UART_IsTXFIFOFull(UART_TypeDef * UARTx)
{
	return (UARTx->CTRL & UART_CTRL_TXFF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_SetBaudrate()
* ˵:	ò
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*			uint32_t baudrate		ҪõĲ
*     : 
* ע: ҪڴڹʱĲʣʹô˺ǰȵUART_Close()رմ
******************************************************************************************************************************************/
void UART_SetBaudrate(UART_TypeDef * UARTx, uint32_t baudrate)
{
	UARTx->BAUD &= ~(UART_BAUD_BAUD_Msk | UART_BAUD_FRAC_Msk);
	UARTx->BAUD |= (((SystemCoreClock/baudrate - 1) / 16) << UART_BAUD_BAUD_Pos) |
				   (((SystemCoreClock/baudrate - 1) % 16) << UART_BAUD_FRAC_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_GetBaudrate()
* ˵:	ѯ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*     : uint32_t				ǰ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_GetBaudrate(UART_TypeDef * UARTx)
{
	return SystemCoreClock/(((UARTx->BAUD & UART_BAUD_BAUD_Msk) >> UART_BAUD_BAUD_Pos) * 16 +
	                        ((UARTx->BAUD & UART_BAUD_FRAC_Msk) >> UART_BAUD_FRAC_Pos) + 1);
}

/****************************************************************************************************************************************** 
* :	UART_CTSConfig()
* ˵:	UART CTS
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*			uint32_t enable			1 ʹCTS    0 ֹCTS
*			uint32_t polarity		0 CTSΪͱʾԷ    1 CTSΪ߱ʾԷ
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_CTSConfig(UART_TypeDef * UARTx, uint32_t enable, uint32_t polarity)
{
	UARTx->CTSCR &= ~(UART_CTSCR_EN_Msk | UART_CTSCR_POL_Msk);
	UARTx->CTSCR |= (enable   << UART_CTSCR_EN_Pos) |
					(polarity << UART_CTSCR_POL_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_CTSLineState()
* ˵:	UART CTSߵǰ״̬
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*     : uint32_t				0 CTSߵǰΪ͵ƽ    1 CTSߵǰΪߵƽ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_CTSLineState(UART_TypeDef * UARTx)
{
	return (UARTx->CTSCR & UART_CTSCR_STAT_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_RTSConfig()
* ˵:	UART RTS
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*			uint32_t enable			1 ʹRTS    0 ֹRTS
*			uint32_t polarity		0 RTSͱʾԽ    1 RTS߱ʾԽ
*			uint32_t threshold		RTSصĴֵȡֵUART_RTS_1BYTEUART_RTS_2BYTEUART_RTS_4BYTEUART_RTS_6BYTE
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_RTSConfig(UART_TypeDef * UARTx, uint32_t enable, uint32_t polarity, uint32_t threshold)
{
	UARTx->RTSCR &= ~(UART_RTSCR_EN_Msk | UART_RTSCR_POL_Msk | UART_RTSCR_THR_Msk);
	UARTx->RTSCR |= (enable    << UART_RTSCR_EN_Pos)  |
					(polarity  << UART_RTSCR_POL_Pos) |
					(threshold << UART_RTSCR_THR_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_RTSLineState()
* ˵:	UART RTSߵǰ״̬
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*     : uint32_t				0 RTSߵǰΪ͵ƽ    1 RTSߵǰΪߵƽ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_RTSLineState(UART_TypeDef * UARTx)
{
	return (UARTx->RTSCR & UART_RTSCR_STAT_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_LINConfig()
* ˵:	UART LIN
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*			uint32_t detectedLen	⵽BreakҪĵ͵ƽȣλȡֵ1--16
*			uint32_t detectedIEn	⵽Breakжʹ
*			uint32_t generatedLen	Break͵͵ƽȣȡֵ1--15
*			uint32_t generatedIEn	Breakжʹ
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_LINConfig(UART_TypeDef * UARTx, uint32_t detectedLen, uint32_t detectedIEn, uint32_t generatedLen, uint32_t generatedIEn)
{
	UARTx->CFG &= ~(UART_CFG_BRKTXLEN_Msk | UART_CFG_BRKRXLEN_Msk);
	UARTx->CFG |= ((detectedLen-1) << UART_CFG_BRKRXLEN_Pos) |
				  (generatedLen    << UART_CFG_BRKTXLEN_Pos);
	UARTx->LINCR &= ~(UART_LINCR_BRKDETIE_Msk | UART_LINCR_GENBRKIE_Msk);
	UARTx->LINCR |= (detectedIEn  << UART_LINCR_BRKDETIE_Pos) |
					(generatedIEn << UART_LINCR_GENBRKIE_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_LINGenerate()
* ˵:	UART LIN/Break
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_LINGenerate(UART_TypeDef * UARTx)
{
	UARTx->LINCR |= (1 << UART_LINCR_GENBRK_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_LININTEn()
* ˵:	LIN жʹ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
* 			uint32_t it				interrupt typeЧֵ UART_IT_LIN_DETUART_IT_LIN_GEN 䡰
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_LININTEn(UART_TypeDef * UARTx, uint32_t it)
{
	UARTx->LINCR |= it;
}

/****************************************************************************************************************************************** 
* :	UART_LININTDis()
* ˵:	LIN жϽֹ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
* 			uint32_t it				interrupt typeЧֵ UART_IT_LIN_DETUART_IT_LIN_GEN 䡰
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_LININTDis(UART_TypeDef * UARTx, uint32_t it)
{
	UARTx->LINCR &= ~it;
}

/****************************************************************************************************************************************** 
* :	UART_LININTClr()
* ˵:	LIN жϱ־
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
* 			uint32_t it				interrupt typeЧֵ UART_IT_LIN_DETUART_IT_LIN_GEN 䡰
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_LININTClr(UART_TypeDef * UARTx, uint32_t it)
{
	UARTx->LINCR |= (it << 1);
}

/****************************************************************************************************************************************** 
* :	UART_LININTStat()
* ˵:	LIN ж״̬ѯ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
* 			uint32_t it				interrupt typeЧֵ UART_IT_LIN_DETUART_IT_LIN_GEN 䡰
*     : uint32_t				0 жѷ    0 жδ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_LININTStat(UART_TypeDef * UARTx, uint32_t it)
{
	return (UARTx->LINCR & (it << 1));
}

uint8_t UART_LIN_IDParity(uint8_t lin_id)
{
	struct {
		uint8_t b0 : 1;
		uint8_t b1 : 1;
		uint8_t b2 : 1;
		uint8_t b3 : 1;
		uint8_t b4 : 1;
		uint8_t b5 : 1;
		uint8_t b6 : 1;
		uint8_t b7 : 1;
	} * bits = (void *)&lin_id;
	
	uint8_t id_P0 =  (bits->b0 ^ bits->b1 ^ bits->b2 ^ bits->b4);
	uint8_t id_P1 = ~(bits->b1 ^ bits->b3 ^ bits->b4 ^ bits->b5);
	
	return (lin_id & 0x3F) | (id_P0 << 6) | (id_P1 << 7);
}

uint8_t UART_LIN_Checksum(uint8_t lin_id, uint8_t data[], uint32_t count, bool enhanced_checksum)
{
	uint16_t checksum;
	
	if(enhanced_checksum && ((lin_id & 0x3F) != 60) && ((lin_id & 0x3F) != 61))
		checksum = lin_id;
	else
		checksum = 0x00;
	
	for(int i = 0; i < count; i++)
	{
		checksum += data[i];
		checksum = (checksum & 0xFF) + (checksum >> 8);
	}
	
	return ~checksum;
}

/****************************************************************************************************************************************** 
* :	UART_ABRStart()
* ˵:	UART Զʼ⿪ʼ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*			uint32_t detectChar		Զ⡢㲨ʵļַ
*									8λʱȡֵ0xFF0xFE0xF80x80ֱʾͷ뷢0xFF0xFE0xF80x80
*									9λʱȡֵ0x1FF0x1FE0x1F80x180ֱʾͷ뷢0x1FF0x1FE0x1F80x180
*     : 
* ע: ԶʼʱܿżУ
******************************************************************************************************************************************/
void UART_ABRStart(UART_TypeDef * UARTx, uint32_t detectChar)
{
	uint32_t bits;
	
	if((detectChar == 0xFF) || (detectChar == 0x1FF))      bits = 0;
	else if((detectChar == 0xFE) || (detectChar == 0x1FE)) bits = 1;
	else if((detectChar == 0xF8) || (detectChar == 0x1F8)) bits = 2;
	else if((detectChar == 0x80) || (detectChar == 0x180)) bits = 3;
	else while(1);
	
	UARTx->BAUD &= ~(UART_BAUD_ABREN_Msk | UART_BAUD_ABRBIT_Msk);
	UARTx->BAUD |= (1    << UART_BAUD_ABREN_Pos) |
				   (bits << UART_BAUD_ABRBIT_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_ABRIsDone()
* ˵:	UART ԶǷ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1
*     : uint32_t				0 δ    UART_ABR_RES_OK ɣҳɹ    UART_ABR_RES_ERR ɣʧܡ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_ABRIsDone(UART_TypeDef * UARTx)
{
	if(UARTx->BAUD & UART_BAUD_ABREN_Msk)
	{
		return 0;
	}
	else if(UARTx->BAUD & UART_BAUD_ABRERR_Msk)
	{
		return UART_ABR_RES_ERR;
	}
	else
	{
		return UART_ABR_RES_OK;
	}
}

/****************************************************************************************************************************************** 
* :	UART_INTEn()
* ˵:	жʹ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
* 			uint32_t it				interrupt typeЧֵ UART_IT_RX_THRUART_IT_RX_TOUTUART_IT_TX_THRUART_IT_TX_DONE 䡰
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTEn(UART_TypeDef * UARTx, uint32_t it)
{
	UARTx->CTRL |= it;
}

/****************************************************************************************************************************************** 
* :	UART_INTDis()
* ˵:	жϽֹ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
* 			uint32_t it				interrupt typeЧֵ UART_IT_RX_THRUART_IT_RX_TOUTUART_IT_TX_THRUART_IT_TX_DONE 䡰
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTDis(UART_TypeDef * UARTx, uint32_t it)
{
	UARTx->CTRL &= ~it;
}

/****************************************************************************************************************************************** 
* :	UART_INTClr()
* ˵:	жϱ־
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
* 			uint32_t it				interrupt typeЧֵ UART_IT_RX_TOUT
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTClr(UART_TypeDef * UARTx, uint32_t it)
{
	if(it & UART_IT_RX_TOUT)
		UARTx->TOCR |= UART_TOCR_IFCLR_Msk;
}

/****************************************************************************************************************************************** 
* :	UART_INTStat()
* ˵:	ж״̬ѯ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
* 			uint32_t it				interrupt typeЧֵ UART_IT_RX_THRUART_IT_RX_TOUTUART_IT_TX_THRUART_IT_TX_DONE 䡰
*     : uint32_t				1 жѷ    0 жδ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_INTStat(UART_TypeDef * UARTx, uint32_t it)
{
	return (((it & UART_IT_RX_THR)  && (UARTx->BAUD & UART_BAUD_RXIF_Msk)) ||
			((it & UART_IT_RX_TOUT) && (UARTx->BAUD & UART_BAUD_TOIF_Msk)) ||
			((it & UART_IT_TX_THR)  && (UARTx->BAUD & UART_BAUD_TXIF_Msk)) ||
			((it & UART_IT_TX_DONE) && (UARTx->BAUD & UART_BAUD_TXDOIF_Msk)));
}
