/****************************************************************************************************************************************** 
* ļ: SWM221_wdt.c
* ˵:	SWM221ƬWDTŹ
* ֧:	http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע:
* 汾:	V1.0.0		2016130
* ¼:  
*
*
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology
*******************************************************************************************************************************************/
#include "SWM221.h"
#include "SWM221_wdt.h"


/****************************************************************************************************************************************** 
* :	WDT_Init()
* ˵:	WDTŹʼ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*			uint32_t int_period		жڣȡֵ1--65534λ1/1000룬ȡֵ0ʾرWDTжϹ
*			uint32_t rst_period		λڣȡֵ1--65534λ1/1000룬ȡֵ0ʾرWDTλ
*     : 
* ע: ˺ֻоƬϵһΣҪ WDT WDT_ReInit()
******************************************************************************************************************************************/
void WDT_Init(WDT_TypeDef * WDTx, uint32_t int_period, uint32_t rst_period)
{
	SYS->CLKEN0 |= (1 << SYS_CLKEN0_WDT_Pos);
	
	WDTx->CR &= ~WDT_CR_CLKDIV_Msk;
	WDTx->CR |= (4 << WDT_CR_CLKDIV_Pos);		//ʱ32Ƶ
	
	if(int_period == 0)
	{
		WDTx->CR &= ~(1 << WDT_CR_INTEN_Pos);
		
		NVIC_DisableIRQ(WDT_IRQn);
	}
	else
	{
		WDTx->CR |=  (1 << WDT_CR_INTEN_Pos);
		
		WDTx->INTVAL = int_period;
		
		WDTx->IF = 1;
		NVIC_EnableIRQ(WDT_IRQn);
	}
	
	if(rst_period == 0)
	{
		WDTx->CR &= ~(1 << WDT_CR_RSTEN_Pos);
		
		WDTx->RSTVAL = int_period + 1;
	}
	else
	{
		WDTx->CR |=  (1 << WDT_CR_RSTEN_Pos);
		
		WDTx->RSTVAL = rst_period;
	}
}

/****************************************************************************************************************************************** 
* :	WDT_ReInit()
* ˵:	WDTŹ³ʼ
*     : ͬ WDT_Init()
*     : 
* ע: ִ WDT_ReInit() ǰ벻Ҫִ WDT_Stop()Ϊ WDT ֹͣ״̬޷ڲ
******************************************************************************************************************************************/
void WDT_ReInit(WDT_TypeDef * WDTx, uint32_t int_period, uint32_t rst_period)
{
	int i;
	
	/* WDT ѾУõ rst_period ȵǰֵСWDT Ҫ 2^16  0 ܴжϺ͸λ
	   ִһι֤¼ */
	WDT_Feed(WDTx);
	
	/* ȴ WDT ڲι */
	for(i = 0; i < CyclesPerUs * 300 / 4; i++) __NOP();
	
	WDT_Stop(WDTx);
	
	WDT_Init(WDTx, int_period, rst_period);
}

/****************************************************************************************************************************************** 
* :	WDT_Start()
* ˵:	ָWDTʼʱ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_Start(WDT_TypeDef * WDTx)
{
	WDTx->CR |=  (1 << WDT_CR_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	WDT_Stop()
* ˵:	رָWDTֹͣʱ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_Stop(WDT_TypeDef * WDTx)
{
	WDTx->CR &= ~(1 << WDT_CR_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	WDT_Feed()
* ˵:	ι´װֵʼʱ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_Feed(WDT_TypeDef * WDTx)
{
	if(WDTx->CR & WDT_CR_EN_Msk) // WDT ֹͣ״̬£ִι
		WDTx->FEED = 0x55;
}

/****************************************************************************************************************************************** 
* :	WDT_INTClr()
* ˵:	жϱ־
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_INTClr(WDT_TypeDef * WDTx)
{
	WDTx->IF = 1;
}

/****************************************************************************************************************************************** 
* :	WDT_INTStat()
* ˵:	ж״̬ѯ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : int32_t					1 ж    0 δж
* ע: 
******************************************************************************************************************************************/
uint32_t WDT_INTStat(WDT_TypeDef * WDTx)
{
	return WDTx->IF;
}
